'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  '*': ['accesskey', 'class', 'contenteditable', 'dir', 'draggable', 'hidden', 'id', 'is', 'itemid', 'itemprop', 'itemref', 'itemscope', 'itemtype', 'lang', 'slot', 'spellcheck', 'style', 'tabindex', 'title', 'translate'],
  'a': ['accesskey', 'charset', 'coords', 'download', 'href', 'hreflang', 'name', 'ping', 'referrerpolicy', 'rel', 'rev', 'shape', 'tabindex', 'target', 'type'],
  'abbr': ['title'],
  'applet': ['align', 'alt', 'archive', 'code', 'codebase', 'height', 'hspace', 'name', 'object', 'vspace', 'width'],
  'area': ['accesskey', 'alt', 'coords', 'download', 'href', 'hreflang', 'nohref', 'ping', 'referrerpolicy', 'rel', 'shape', 'tabindex', 'target', 'type'],
  'audio': ['autoplay', 'controls', 'crossorigin', 'loop', 'mediagroup', 'muted', 'preload', 'src'],
  'base': ['href', 'target'],
  'basefont': ['color', 'face', 'size'],
  'bdo': ['dir'],
  'blockquote': ['cite'],
  'body': ['alink', 'background', 'bgcolor', 'link', 'text', 'vlink'],
  'br': ['clear'],
  'button': ['accesskey', 'autofocus', 'disabled', 'form', 'formaction', 'formenctype', 'formmethod', 'formnovalidate', 'formtarget', 'name', 'tabindex', 'type', 'value'],
  'canvas': ['height', 'width'],
  'caption': ['align'],
  'col': ['align', 'char', 'charoff', 'span', 'valign', 'width'],
  'colgroup': ['align', 'char', 'charoff', 'span', 'valign', 'width'],
  'data': ['value'],
  'del': ['cite', 'datetime'],
  'details': ['open'],
  'dfn': ['title'],
  'dialog': ['open'],
  'dir': ['compact'],
  'div': ['align'],
  'dl': ['compact'],
  'embed': ['height', 'src', 'type', 'width'],
  'fieldset': ['disabled', 'form', 'name'],
  'font': ['color', 'face', 'size'],
  'form': ['accept', 'accept-charset', 'action', 'autocomplete', 'enctype', 'method', 'name', 'novalidate', 'target'],
  'frame': ['frameborder', 'longdesc', 'marginheight', 'marginwidth', 'name', 'noresize', 'scrolling', 'src'],
  'frameset': ['cols', 'rows'],
  'h1': ['align'],
  'h2': ['align'],
  'h3': ['align'],
  'h4': ['align'],
  'h5': ['align'],
  'h6': ['align'],
  'head': ['profile'],
  'hr': ['align', 'noshade', 'size', 'width'],
  'html': ['manifest', 'version'],
  'iframe': ['align', 'allowfullscreen', 'allowpaymentrequest', 'allowusermedia', 'frameborder', 'height', 'longdesc', 'marginheight', 'marginwidth', 'name', 'referrerpolicy', 'sandbox', 'scrolling', 'src', 'srcdoc', 'width'],
  'img': ['align', 'alt', 'border', 'crossorigin', 'height', 'hspace', 'ismap', 'longdesc', 'name', 'referrerpolicy', 'sizes', 'src', 'srcset', 'usemap', 'vspace', 'width'],
  'input': ['accept', 'accesskey', 'align', 'alt', 'autocomplete', 'autofocus', 'checked', 'dirname', 'disabled', 'form', 'formaction', 'formenctype', 'formmethod', 'formnovalidate', 'formtarget', 'height', 'inputmode', 'ismap', 'list', 'max', 'maxlength', 'min', 'minlength', 'multiple', 'name', 'pattern', 'placeholder', 'readonly', 'required', 'size', 'src', 'step', 'tabindex', 'title', 'type', 'usemap', 'value', 'width'],
  'ins': ['cite', 'datetime'],
  'isindex': ['prompt'],
  'keygen': ['autofocus', 'challenge', 'disabled', 'form', 'keytype', 'name'],
  'label': ['accesskey', 'for', 'form'],
  'legend': ['accesskey', 'align'],
  'li': ['type', 'value'],
  'link': ['as', 'charset', 'color', 'crossorigin', 'href', 'hreflang', 'integrity', 'media', 'nonce', 'referrerpolicy', 'rel', 'rev', 'scope', 'sizes', 'target', 'title', 'type', 'updateviacache', 'workertype'],
  'map': ['name'],
  'menu': ['compact'],
  'meta': ['charset', 'content', 'http-equiv', 'name', 'scheme'],
  'meter': ['high', 'low', 'max', 'min', 'optimum', 'value'],
  'object': ['align', 'archive', 'border', 'classid', 'codebase', 'codetype', 'data', 'declare', 'form', 'height', 'hspace', 'name', 'standby', 'tabindex', 'type', 'typemustmatch', 'usemap', 'vspace', 'width'],
  'ol': ['compact', 'reversed', 'start', 'type'],
  'optgroup': ['disabled', 'label'],
  'option': ['disabled', 'label', 'selected', 'value'],
  'output': ['for', 'form', 'name'],
  'p': ['align'],
  'param': ['name', 'type', 'value', 'valuetype'],
  'pre': ['width'],
  'progress': ['max', 'value'],
  'q': ['cite'],
  'script': ['async', 'charset', 'crossorigin', 'defer', 'integrity', 'language', 'nomodule', 'nonce', 'src', 'type'],
  'select': ['autocomplete', 'autofocus', 'disabled', 'form', 'multiple', 'name', 'required', 'size', 'tabindex'],
  'slot': ['name'],
  'source': ['media', 'sizes', 'src', 'srcset', 'type'],
  'style': ['media', 'nonce', 'title', 'type'],
  'table': ['align', 'bgcolor', 'border', 'cellpadding', 'cellspacing', 'frame', 'rules', 'summary', 'width'],
  'tbody': ['align', 'char', 'charoff', 'valign'],
  'td': ['abbr', 'align', 'axis', 'bgcolor', 'char', 'charoff', 'colspan', 'headers', 'height', 'nowrap', 'rowspan', 'scope', 'valign', 'width'],
  'textarea': ['accesskey', 'autocomplete', 'autofocus', 'cols', 'dirname', 'disabled', 'form', 'inputmode', 'maxlength', 'minlength', 'name', 'placeholder', 'readonly', 'required', 'rows', 'tabindex', 'wrap'],
  'tfoot': ['align', 'char', 'charoff', 'valign'],
  'th': ['abbr', 'align', 'axis', 'bgcolor', 'char', 'charoff', 'colspan', 'headers', 'height', 'nowrap', 'rowspan', 'scope', 'valign', 'width'],
  'thead': ['align', 'char', 'charoff', 'valign'],
  'time': ['datetime'],
  'tr': ['align', 'bgcolor', 'char', 'charoff', 'valign'],
  'track': ['default', 'kind', 'label', 'src', 'srclang'],
  'ul': ['compact', 'type'],
  'video': ['autoplay', 'controls', 'crossorigin', 'height', 'loop', 'mediagroup', 'muted', 'playsinline', 'poster', 'preload', 'src', 'width']
};