const React = require("react");
const tag = require("tag-hoc").default;
const color = require("./color");
const styled = require("./styled");
module.exports = Window;
function Window(props) {
    const paddingTop = props.decorations ? props.paddingY + 40 : props.paddingY;
    const paddingBottom = props.decorations ? props.paddingY + 20 : props.paddingY;
    const paddingX = props.decorations ? props.paddingX + 20 : props.paddingX;
    const width = props.width * 10 + paddingX * 2;
    const height = props.height * 10 + paddingTop + paddingBottom;
    return (React.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", xmlnsXlink: "http://www.w3.org/1999/xlink", width: width, height: height },
        React.createElement(StyledBackground, { key: "bg", width: width, height: height, rx: props.decorations ? 5 : 0, ry: props.decorations ? 5 : 0, theme: props.theme }),
        props.decorations &&
            React.createElement("svg", { y: "0%", x: "0%" },
                React.createElement(StyledDot, { key: "red", cx: 20, cy: 20, r: 6, bgColor: "#ff5f58" }),
                React.createElement(StyledDot, { key: "yellow", cx: 40, cy: 20, r: 6, bgColor: "#ffbd2e" }),
                React.createElement(StyledDot, { key: "green", cx: 60, cy: 20, r: 6, bgColor: "#18c132" })),
        props.children));
}
const StyledBackground = styled.rect `
  fill: ${props => color(props.theme.background)};
`;
const StyledDot = styled.circle `
  fill: ${props => props.bgColor};
`;
//# sourceMappingURL=Window.js.map